/*
 * $Id: $
 * 
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 * 
 * DO NOT EDIT THIS FILE!
 * This file is auto-generated.
 * Edits to this file will be lost when it is regenerated.
 */

#ifndef __BCM_INT_H__
#define __BCM_INT_H__

#include <bcm/types.h>

#if defined(INCLUDE_INT)
/* INT Turnaround configuration information data. */
typedef struct bcm_int_turnaround_config_s {
    bcm_mac_t src_mac; 
} bcm_int_turnaround_config_t;
#endif

#if defined(INCLUDE_INT)
/* INT Turnaround statistics information data. */
typedef struct bcm_int_turnaround_stat_s {
    uint64 rx_pkt_cnt;                  /* Number of packet recieved in FW. */
    uint64 tx_pkt_cnt;                  /* Number of packet transmitted from FW. */
    uint64 drop_pkt_cnt;                /* Number of packet dropped in FW. */
    uint64 int_init_config_drop;        /* Number of pkt dropped due to missing
                                           configuration. */
    uint64 int_hop_cnt_invalid_drop;    /* Number of pkt dropped due to Hop
                                           count exceeded Hop limit. */
    uint64 int_hdr_len_invalid_drop;    /* Number of pkt dropped due to current
                                           length exceeded maximum length. */
    uint64 int_pkt_size_invalid_drop;   /* Number of pkt dropped due to invalid
                                           packet size. */
} bcm_int_turnaround_stat_t;
#endif

#ifndef BCM_HIDE_DISPATCHABLE

#if defined(INCLUDE_INT)
/* Initialize the In-band Telemetry(INT) subsystem. */
extern int bcm_int_init(
    int unit);
#endif

#if defined(INCLUDE_INT)
/* Shut down the In-band Telemetry(INT) subsystem. */
extern int bcm_int_detach(
    int unit);
#endif

#endif /* BCM_HIDE_DISPATCHABLE */

#if defined(INCLUDE_INT)
/* Initialize INT Turnaround configuration information structure. */
extern void bcm_int_turnaround_config_t_init(
    bcm_int_turnaround_config_t *config_info);
#endif

#ifndef BCM_HIDE_DISPATCHABLE

#if defined(INCLUDE_INT)
/* Set INT Turnaround - configuration information */
extern int bcm_int_turnaround_config_set(
    int unit, 
    bcm_int_turnaround_config_t *config_data);
#endif

#if defined(INCLUDE_INT)
/* Get INT Turnaround - configuration information */
extern int bcm_int_turnaround_config_get(
    int unit, 
    bcm_int_turnaround_config_t *config_data);
#endif

#if defined(INCLUDE_INT)
/* Get INT Turnaround - statistics information */
extern int bcm_int_turnaround_stat_get(
    int unit, 
    bcm_int_turnaround_stat_t *stat_data);
#endif

#endif /* BCM_HIDE_DISPATCHABLE */

#endif /* __BCM_INT_H__ */
