/*
 * $Id: $
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 *
 * File:        ft_field.h
 * Purpose:     Flowtracker module specific routines in flowtracker
 *              stage in FP.
 */

#ifndef _BCM_INT_FT_FIELD_H
#define _BCM_INT_FT_FIELD_H

#include <soc/defs.h>

#if defined(BCM_FLOWTRACKER_SUPPORT)
#include <bcm/flowtracker.h>

extern int
_bcm_field_ft_group_tracking_info_process(
        int unit,
        bcm_flowtracker_group_t id,
        uint8 save_output);

extern int
_bcm_field_ft_group_extraction_clear(
        int unit,
        bcm_flowtracker_group_t id);

extern int
_bcm_field_ft_group_control_set(
        int unit,
        bcm_flowtracker_group_t id,
        bcm_flowtracker_group_control_type_t control_type,
        int param);

extern int
_bcm_field_ft_group_invalidate(int unit);

extern int
_bcm_field_ft_tracking_param_range_get(
        int unit,
        bcm_flowtracker_tracking_param_type_t param,
        uint32 *min_value,
        uint32 *max_value);

/*
 * Typedef:
 *     ALU Data flags.
 * Purpose:
 *
 */
typedef enum _bcm_field_ft_alu_data_e {
    _bcmFieldFtAluDataTcpFlagsFIN,

    _bcmFieldFtAluDataTcpFlagsSYN,

    _bcmFieldFtAluDataTcpFlagsRST,

    _bcmFieldFtAluDataTcpFlagsPSH,

    _bcmFieldFtAluDataTcpFlagsACK,

    _bcmFieldFtAluDataTcpFlagsURG,

    _bcmFieldFtAluDataTcpFlagsECE,

    _bcmFieldFtAluDataTcpFlagsCWR,

    _bcmFieldFtAluDataCount
} _bcm_field_ft_alu_data_t;


/* Get alu data related config. */
extern int
_bcm_field_ft_alu_data_config_get(
        int unit,
        bcm_flowtracker_group_t id,
        _bcm_field_ft_alu_data_t alu_data,
        int *offset,
        int *width);

extern int
_bcm_field_ft_session_profiles_recover(
        int unit,
        bcm_flowtracker_group_t id);

#endif /* BCM_FLOWTRACKER_SUPPORT */

#endif /* _BCM_INT_FT_FIELD_H */
