/*
 * $Id: $
 * 
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 * 
 * DO NOT EDIT THIS FILE!
 * This file is auto-generated.
 * Edits to this file will be lost when it is regenerated.
 */

#ifndef __BCMX_MCAST_H__
#define __BCMX_MCAST_H__

#include <bcm/types.h>
#include <bcmx/bcmx.h>
#include <bcmx/lplist.h>
#include <bcm/mcast.h>

/* Device-independent L2 multicast address. */
typedef struct bcmx_mcast_addr_s {
    bcm_mac_t mac;              /* 802.3 MAC address. */
    bcm_vlan_t vid;             /* VLAN identifier. */
    bcm_cos_t cos_dst;          /* COS based on destination address. */
    bcmx_lplist_t ports;        /* Port list. */
    bcmx_lplist_t untag_ports;  /* Untagged port bitmap. */
    uint32 l2mc_index;          /* XGS: L2MC index. */
} bcmx_mcast_addr_t;

/* Initialize bcmx_mcast_addr_t and allocate port lists. */
extern void bcmx_mcast_addr_t_init(
    bcmx_mcast_addr_t *mcaddr, 
    bcm_mac_t mac, 
    bcm_vlan_t vid);

/* Backward compatibility. */
#define bcmx_mcast_addr_init    bcmx_mcast_addr_t_init 

/* Deallocate port lists in bcmx_mcast_addr_t. */
extern void bcmx_mcast_addr_t_free(
    bcmx_mcast_addr_t *mcaddr);

/* Backward compatibility. */
#define bcmx_mcast_addr_free    bcmx_mcast_addr_t_free 

/* Initialize the L2 multicast module. */
extern int bcmx_mcast_init(void);

/* Add/Remove an entry in the multicast table. */
extern int bcmx_mcast_addr_add(
    bcmx_mcast_addr_t *mcaddr);

/* Add/Remove an entry in the multicast table. */
extern int bcmx_mcast_addr_remove(
    bcm_mac_t mac, 
    bcm_vlan_t vid);

/* 
 * Get untagged and tagged membership port bit maps for a Multicast
 * group.
 */
extern int bcmx_mcast_port_get(
    bcm_mac_t mac, 
    bcm_vlan_t vid, 
    bcmx_mcast_addr_t *mcaddr);

/* Add a given port to the membership of a given multicast group. */
extern int bcmx_mcast_join(
    bcm_mac_t mac, 
    bcm_vlan_t vid, 
    bcmx_lport_t port, 
    bcmx_mcast_addr_t *mcaddr, 
    bcmx_lplist_t *allrtr);

/* Remove a given port from the membership of a given multicast group. */
extern int bcmx_mcast_leave(
    bcm_mac_t mac, 
    bcm_vlan_t vid, 
    bcmx_lport_t port);

/* Add/Remove ports to/from an existing entry in the multicast table. */
extern int bcmx_mcast_port_remove(
    bcmx_mcast_addr_t *mcaddr);

/* Add/Remove ports to/from an existing entry in the multicast table. */
extern int bcmx_mcast_port_add(
    bcmx_mcast_addr_t *mcaddr);

#endif /* __BCMX_MCAST_H__ */
