/*
 * $Id: $
 * 
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 * 
 * DO NOT EDIT THIS FILE!
 * This file is auto-generated.
 * Edits to this file will be lost when it is regenerated.
 */

#ifndef __BCMX_STAT_H__
#define __BCMX_STAT_H__

#include <bcm/types.h>
#include <bcmx/bcmx.h>
#include <bcm/stat.h>

/* Initialize the Statistics module. */
extern int bcmx_stat_init(void);

/* Clear the port-based statistics for the indicated device port. */
extern int bcmx_stat_clear(
    bcmx_lport_t port);

/* Synchronize software counters with hardware. */
extern int bcmx_stat_sync(void);

/* Get the specified statistics from the device. */
extern int bcmx_stat_get(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    uint64 *value);

/* Get the specified statistics from the device. */
extern int bcmx_stat_get32(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    uint32 *value);

/* Get the specified statistics. */
extern int bcmx_stat_multi_get(
    bcm_gport_t port, 
    int nstat, 
    bcm_stat_val_t *stat_arr, 
    uint64 *value_arr);

/* 
 * Get the specified statistics.  The 64-bit values may be truncated to
 * fit.
 */
extern int bcmx_stat_multi_get32(
    bcm_gport_t port, 
    int nstat, 
    bcm_stat_val_t *stat_arr, 
    uint32 *value_arr);

/* Set/get debug counter to count certain packet types. */
extern int bcmx_stat_custom_set(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    uint32 flags);

/* Set/get debug counter to count certain packet types. */
extern int bcmx_stat_custom_get(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    uint32 *flags);

/* Add a certain packet type to debug counter to count. */
extern int bcmx_stat_custom_add(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    bcm_custom_stat_trigger_t trigger);

/* Delete the specified packet type from debug counter. */
extern int bcmx_stat_custom_delete(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    bcm_custom_stat_trigger_t trigger);

/* Delete all packet types from debug counter. */
extern int bcmx_stat_custom_delete_all(
    bcmx_lport_t port, 
    bcm_stat_val_t type);

/* Check if specified packet types is part of debug counter. */
extern int bcmx_stat_custom_check(
    bcmx_lport_t port, 
    bcm_stat_val_t type, 
    bcm_custom_stat_trigger_t trigger, 
    int *result);

#endif /* __BCMX_STAT_H__ */
