/*
 * $Id: sdk_config.h,v 1.5 Broadcom SDK $
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 *
 *
 */

#ifndef __SDK_CONFIG_H__
#define __SDK_CONFIG_H__

/*
 * Include custom overrides
 */
#ifdef SDK_INCLUDE_CUSTOM_CONFIG
#include <sdk_custom_config.h>
#endif


/*
 * Memory Barrier operation if required. 
 * Defaults to nothing. 
 */
#ifndef SDK_CONFIG_MEMORY_BARRIER
#if defined(__PPC__)
#define SDK_CONFIG_MEMORY_BARRIER  __asm__ __volatile__ ("sync":::"memory")
#elif defined(__x86_64__)
#define SDK_CONFIG_MEMORY_BARRIER __asm__ __volatile__("mfence":::"memory")
#elif defined(__i386__)
#define SDK_CONFIG_MEMORY_BARRIER __asm__ __volatile__("":::"memory")
#elif defined(__ARMEL__)
#define SDK_CONFIG_MEMORY_BARRIER  asm volatile("dmb ish":::"memory")
#else
#error Unsupported CPU architecture
#endif
#endif



#endif /* __SDK_CONFIG_H__ */
