/*
 *         
 * $Id:$
 * 
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 *         
 *     
 * DO NOT EDIT THIS FILE!
 *
 */

#ifndef _CPRIMOD_DISPATCH_H__H_
#define _CPRIMOD_DISPATCH_H__H_

#include <soc/types.h>
#include <bcm/types.h>
#include <shared/cpri.h>
#include <phymod/phymod.h>
#include <phymod/phymod_diagnostics.h>
#include <soc/cprimod/cprimod.h>

typedef int (*__dispatch__cprimod_test_api_dispatch_f)(int unit, int port, int* value);
typedef int (*__dispatch__cprimod_basic_frame_parser_active_table_set_f)(int unit, int port, cprimod_basic_frame_table_id_t table);
typedef int (*__dispatch__cprimod_basic_frame_parser_active_table_get_f)(int unit, int port, cprimod_basic_frame_table_id_t* table);
typedef int (*__dispatch__cprimod_basic_frame_parser_table_num_entries_set_f)(int unit, int port, cprimod_basic_frame_table_id_t table, uint32 num_entries);
typedef int (*__dispatch__cprimod_basic_frame_parser_table_num_entries_get_f)(int unit, int port, cprimod_basic_frame_table_id_t table, uint32* num_entries);
typedef int (*__dispatch__cprimod_basic_frame_assembly_active_table_set_f)(int unit, int port, cprimod_basic_frame_table_id_t table);
typedef int (*__dispatch__cprimod_basic_frame_assembly_active_table_get_f)(int unit, int port, cprimod_basic_frame_table_id_t* table);
typedef int (*__dispatch__cprimod_basic_frame_assembly_table_num_entries_set_f)(int unit, int port, cprimod_basic_frame_table_id_t table, uint32 num_entries);
typedef int (*__dispatch__cprimod_basic_frame_assembly_table_num_entries_get_f)(int unit, int port, cprimod_basic_frame_table_id_t table, uint32* num_entries);
typedef int (*__dispatch__cprimod_rx_axc_basic_frame_add_f)(int unit, int port, uint32 axc_id, uint32 start_bit, uint32 num_bit);
typedef int (*__dispatch__cprimod_rx_axc_basic_frame_delete_f)(int unit, int port, uint32 axc_id);
typedef int (*__dispatch__cprimod_rx_axc_basic_frame_clear_f)(int unit, int port);
typedef int (*__dispatch__cprimod_rx_axc_basic_frame_get_f)(int unit, int port, uint32 axc_id, cprimod_basic_frame_table_id_t table, cprimod_basic_frame_usage_entry_t* usage_table, int* num_entries);
typedef int (*__dispatch__cprimod_tx_axc_basic_frame_add_f)(int unit, int port, uint32 axc_id, uint32 start_bit, uint32 num_bit);
typedef int (*__dispatch__cprimod_tx_axc_basic_frame_delete_f)(int unit, int port, uint32 axc_id);
typedef int (*__dispatch__cprimod_tx_axc_basic_frame_clear_f)(int unit, int port);
typedef int (*__dispatch__cprimod_tx_axc_basic_frame_get_f)(int unit, int port, uint32 axc_id, cprimod_basic_frame_table_id_t table, cprimod_basic_frame_usage_entry_t* usage_table, int* num_entries);
typedef int (*__dispatch__cprimod_basic_frame_debug_f)(int unit, int port, uint32 axc_id, cprimod_basic_frame_table_id_t rx_table, cprimod_basic_frame_table_id_t tx_table, uint32 flags);
typedef int (*__dispatch__cprimod_cpri_rx_axc_container_config_set_f)(int unit, int port, uint32 axc_id, const cprimod_cpri_container_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_rx_axc_container_config_get_f)(int unit, int port, uint32 axc_id, cprimod_cpri_container_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_tx_axc_container_config_set_f)(int unit, int port, uint32 axc_id, const cprimod_cpri_container_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_tx_axc_container_config_get_f)(int unit, int port, uint32 axc_id, cprimod_cpri_container_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_rx_axc_container_config_set_f)(int unit, int port, uint32 flow_id, const cprimod_rsvd4_container_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_rx_axc_container_config_get_f)(int unit, int port, uint32 flow_id, cprimod_rsvd4_container_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_tx_axc_container_config_set_f)(int unit, int port, uint32 flow_id, const cprimod_rsvd4_container_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_tx_axc_container_config_get_f)(int unit, int port, uint32 flow_id, cprimod_rsvd4_container_config_t* config_info);
typedef int (*__dispatch__cprimod_rx_roe_payload_size_set_f)(int unit, int port, uint32 axc_id, const cprimod_payload_size_info_t* config_info);
typedef int (*__dispatch__cprimod_rx_roe_payload_size_get_f)(int unit, int port, uint32 axc_id, cprimod_payload_size_info_t* config_info);
typedef int (*__dispatch__cprimod_tx_roe_payload_size_set_f)(int unit, int port, uint32 axc_id, const cprimod_payload_size_info_t* config_info);
typedef int (*__dispatch__cprimod_tx_roe_payload_size_get_f)(int unit, int port, uint32 axc_id, cprimod_payload_size_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_encap_data_config_set_f)(int unit, int port, uint32 queue_num, const cprimod_encap_decap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_encap_data_config_get_f)(int unit, int port, uint32 queue_num, cprimod_encap_decap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_decap_data_config_set_f)(int unit, int port, uint32 queue_num, const cprimod_encap_decap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_decap_data_config_get_f)(int unit, int port, uint32 queue_num, cprimod_encap_decap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_encap_data_config_set_f)(int unit, int port, uint32 queue_num, const cprimod_rsvd4_encap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_encap_data_config_get_f)(int unit, int port, uint32 queue_num, cprimod_rsvd4_encap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_decap_data_config_set_f)(int unit, int port, uint32 queue_num, const cprimod_rsvd4_decap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_decap_data_config_get_f)(int unit, int port, uint32 queue_num, cprimod_rsvd4_decap_data_config_t* config_info);
typedef int (*__dispatch__cprimod_encap_header_config_set_f)(int unit, int port, uint32 queue_num, const cprimod_encap_header_config_t* config_info);
typedef int (*__dispatch__cprimod_encap_header_config_get_f)(int unit, int port, uint32 queue_num, cprimod_encap_header_config_t* config_info);
typedef int (*__dispatch__cprimod_rx_rsvd4_gsm_tsn_bitmap_set_f)(int unit, int port, uint32 queue_num, uint32 tsn_bitmap);
typedef int (*__dispatch__cprimod_rx_rsvd4_gsm_tsn_bitmap_get_f)(int unit, int port, uint32 queue_num, uint32* tsn_bitmap);
typedef int (*__dispatch__cprimod_encap_ordering_info_entry_set_f)(int unit, int port, uint32 index, const cprimod_encap_ordering_info_entry_t* user_entry);
typedef int (*__dispatch__cprimod_encap_ordering_info_entry_get_f)(int unit, int port, uint32 index, cprimod_encap_ordering_info_entry_t* user_entry);
typedef int (*__dispatch__cprimod_decap_ordering_info_entry_set_f)(int unit, int port, uint32 index, const cprimod_decap_ordering_info_entry_t* user_entry);
typedef int (*__dispatch__cprimod_decap_ordering_info_entry_get_f)(int unit, int port, uint32 index, cprimod_decap_ordering_info_entry_t* user_entry);
typedef int (*__dispatch__cprimod_encap_ordering_info_sequence_offset_set_f)(int unit, int port, uint32 queue, uint32 control, const cprimod_cpri_ordering_info_offset_t* offset_entry);
typedef int (*__dispatch__cprimod_encap_ordering_info_sequence_offset_get_f)(int unit, int port, uint32 queue, uint32 control, uint32 pcnt_size, uint32 qcnt_size, const cprimod_cpri_ordering_info_offset_t* offset_entry);
typedef int (*__dispatch__cprimod_decap_ordering_info_sequence_offset_set_f)(int unit, int port, uint32 queue, const cprimod_cpri_ordering_info_offset_t* offset_entry);
typedef int (*__dispatch__cprimod_decap_ordering_info_sequence_offset_get_f)(int unit, int port, uint32 queue, cprimod_cpri_ordering_info_offset_t* offset_entry);
typedef int (*__dispatch__cprimod_encap_mac_da_entry_set_f)(int unit, int port, uint32 index, cprimod_mac_addr_t addr);
typedef int (*__dispatch__cprimod_encap_mac_da_entry_get_f)(int unit, int port, uint32 index, cprimod_mac_addr_t addr);
typedef int (*__dispatch__cprimod_encap_mac_sa_entry_set_f)(int unit, int port, uint32 index, cprimod_mac_addr_t addr);
typedef int (*__dispatch__cprimod_encap_mac_sa_entry_get_f)(int unit, int port, uint32 index, cprimod_mac_addr_t addr);
typedef int (*__dispatch__cprimod_encap_vlan_id_entry_set_f)(int unit, int port, cprimod_vlan_table_id_t table_id, uint32 index, uint32 vlan_id);
typedef int (*__dispatch__cprimod_encap_vlan_id_entry_get_f)(int unit, int port, cprimod_vlan_table_id_t table_id, uint32 index, uint32* vlan_id);
typedef int (*__dispatch__cprimod_decap_ethertype_config_set_f)(int unit, int port, cprimod_ethertype_t type_id, uint16 ethertype);
typedef int (*__dispatch__cprimod_decap_ethertype_config_get_f)(int unit, int port, cprimod_ethertype_t type_id, uint16* ethertype);
typedef int (*__dispatch__cprimod_encap_ethertype_config_set_f)(int unit, int port, cprimod_ethertype_t type_id, uint16 ethertype);
typedef int (*__dispatch__cprimod_encap_ethertype_config_get_f)(int unit, int port, cprimod_ethertype_t type_id, uint16* ethertype);
typedef int (*__dispatch__cprimod_encap_memory_clear_f)(int unit, int port, int queue_num);
typedef int (*__dispatch__cprimod_cpri_rx_framer_state_clear_f)(int unit, int port, int queue_num);
typedef int (*__dispatch__cprimod_decap_memory_clear_f)(int unit, int port, int queue_num);
typedef int (*__dispatch__cprimod_cpri_tx_framer_state_clear_f)(int unit, int port, int queue_num);
typedef int (*__dispatch__cprimod_decap_flow_classification_config_set_f)(int unit, int port, uint8 subtype, uint32 queue_num, cprimod_cls_option_t cls_option, cprimod_cls_flow_type_t flow_type);
typedef int (*__dispatch__cprimod_decap_flow_classification_config_get_f)(int unit, int port, uint8 subtype, uint32* queue_num, cprimod_cls_option_t* cls_option, cprimod_cls_flow_type_t* flow_type);
typedef int (*__dispatch__cprimod_decap_flow_to_queue_mapping_set_f)(int unit, int port, uint32 flow_id, uint32 queue_num);
typedef int (*__dispatch__cprimod_decap_flow_to_queue_mapping_get_f)(int unit, int port, uint32 flow_id, uint32* queue_num);
typedef int (*__dispatch__cprimod_decap_queue_to_ordering_info_index_mapping_set_f)(int unit, int port, uint32 queue_num, uint32 ordering_info_index);
typedef int (*__dispatch__cprimod_decap_queue_to_ordering_info_index_mapping_get_f)(int unit, int port, uint32 queue_num, uint32* ordering_info_index);
typedef int (*__dispatch__cprimod_tx_framer_tgen_tick_set_f)(int unit, int port, uint32 divider, uint32 basic_frame_tick, uint32 tick_bitmap, uint32 tick_bitmap_size);
typedef int (*__dispatch__cprimod_tx_framer_tgen_tick_get_f)(int unit, int port, uint32* divider, uint32* basic_frame_tick, uint32* tick_bitmap, uint32* tick_bitmap_size);
typedef int (*__dispatch__cprimod_tx_framer_tgen_enable_f)(int unit, int port, uint8 enable);
typedef int (*__dispatch__cprimod_tx_framer_tgen_offset_set_f)(int unit, int port, uint64 timestamp_offset);
typedef int (*__dispatch__cprimod_tx_framer_tgen_offset_get_f)(int unit, int port, uint64* timestamp_offset);
typedef int (*__dispatch__cprimod_tx_framer_tgen_next_bfn_set_f)(int unit, int port, uint32 tgen_bfn);
typedef int (*__dispatch__cprimod_tx_framer_tgen_next_bfn_get_f)(int unit, int port, uint32* tgen_bfn);
typedef int (*__dispatch__cprimod_tx_framer_tgen_next_hfn_set_f)(int unit, int port, uint32 tgen_hfn);
typedef int (*__dispatch__cprimod_tx_framer_tgen_next_hfn_get_f)(int unit, int port, uint32* tgen_hfn);
typedef int (*__dispatch__cprimod_tx_framer_tgen_select_counter_set_f)(int unit, int port, cprimod_tgen_counter_select_t tgen_counter_select);
typedef int (*__dispatch__cprimod_tx_framer_tgen_select_counter_get_f)(int unit, int port, cprimod_tgen_counter_select_t* tgen_counter_select);
typedef int (*__dispatch__cprimod_header_compare_entry_add_f)(int unit, int port, const cprimod_header_compare_entry_t* compare_entry);
typedef int (*__dispatch__cprimod_header_compare_entry_delete_f)(int unit, int port, const cprimod_header_compare_entry_t* compare_entry);
typedef int (*__dispatch__cprimod_header_compare_entry_for_flow_delete_f)(int unit, int port, uint8 flow_id, cprimod_flow_type_t flow_type);
typedef int (*__dispatch__cprimod_modulo_rule_entry_set_f)(int unit, int port, uint8 modulo_rule_num, cprimod_transmission_rule_type_t modulo_rule_type, const cprimod_modulo_rule_entry_t* modulo_rule);
typedef int (*__dispatch__cprimod_modulo_rule_entry_get_f)(int unit, int port, uint8 modulo_rule_num, cprimod_transmission_rule_type_t modulo_rule_type, cprimod_modulo_rule_entry_t* modulo_rule);
typedef int (*__dispatch__cprimod_dual_bitmap_rule_entry_set_f)(int unit, int port, uint8 dbm_rule_num, const cprimod_dbm_rule_entry_t* dbm_rule);
typedef int (*__dispatch__cprimod_dual_bitmap_rule_entry_get_f)(int unit, int port, uint8 dbm_rule_num, cprimod_dbm_rule_entry_t* dbm_rule);
typedef int (*__dispatch__cprimod_secondary_dual_bitmap_rule_entry_set_f)(int unit, int port, uint8 dbm_rule_num, const cprimod_secondary_dbm_rule_entry_t* dbm_rule);
typedef int (*__dispatch__cprimod_secondary_dual_bitmap_rule_entry_get_f)(int unit, int port, uint8 dbm_rule_num, cprimod_secondary_dbm_rule_entry_t* dbm_rule);
typedef int (*__dispatch__cprimod_dbm_position_entry_set_f)(int unit, int port, uint8 index, const cprimod_dbm_pos_table_entry_t* pos_entry);
typedef int (*__dispatch__cprimod_dbm_position_entry_get_f)(int unit, int port, uint8 index, cprimod_dbm_pos_table_entry_t* pos_entry);
typedef int (*__dispatch__cprimod_port_rx_interface_config_set_f)(int unit, int port, const phymod_phy_access_t* phy, const cprimod_port_interface_config_t* config);
typedef int (*__dispatch__cprimod_port_rx_interface_config_get_f)(int unit, int port, cprimod_port_interface_config_t* config);
typedef int (*__dispatch__cprimod_port_tx_interface_config_set_f)(int unit, int port, const phymod_phy_access_t* phy, const cprimod_port_interface_config_t* config);
typedef int (*__dispatch__cprimod_port_tx_interface_config_get_f)(int unit, int port, cprimod_port_interface_config_t* config);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_config_set_f)(int unit, int port, const cprimod_port_rsvd4_config_t* config);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_config_get_f)(int unit, int port, cprimod_port_rsvd4_config_t* config);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_config_set_f)(int unit, int port, const cprimod_port_rsvd4_config_t* config);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_config_get_f)(int unit, int port, cprimod_port_rsvd4_config_t* config);
typedef int (*__dispatch__cprimod_port_rx_frame_optional_config_set_f)(int unit, int port, cprimod_rx_config_field_t field, int value);
typedef int (*__dispatch__cprimod_port_rx_frame_optional_config_get_f)(int unit, int port, cprimod_rx_config_field_t field, int* value);
typedef int (*__dispatch__cprimod_port_tx_frame_optional_config_set_f)(int unit, int port, cprimod_tx_config_field_t field, uint32 value);
typedef int (*__dispatch__cprimod_port_tx_frame_optional_config_get_f)(int unit, int port, cprimod_tx_config_field_t field, uint32* value);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_frame_optional_config_set_f)(int unit, int port, cprimod_rsvd4_rx_config_field_t field, int value);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_frame_optional_config_get_f)(int unit, int port, cprimod_rsvd4_rx_config_field_t field, int* value);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_speed_set_f)(int unit, int port, const phymod_phy_access_t* phy, cprimod_port_rsvd4_speed_mult_t speed);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_speed_get_f)(int unit, int port, cprimod_port_rsvd4_speed_mult_t* speed);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_speed_set_f)(int unit, int port, const phymod_phy_access_t* phy, cprimod_port_rsvd4_speed_mult_t speed);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_speed_get_f)(int unit, int port, cprimod_port_rsvd4_speed_mult_t* speed);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_fsm_state_set_f)(int unit, int port, cprimod_rsvd4_rx_fsm_state_t state);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_fsm_state_get_f)(int unit, int port, cprimod_rsvd4_rx_fsm_state_t* state);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_overide_set_f)(int unit, int port, cprimod_rsvd4_rx_overide_t parameter, int enable, int value);
typedef int (*__dispatch__cprimod_port_rsvd4_rx_overide_get_f)(int unit, int port, cprimod_rsvd4_rx_overide_t parameter, int* enable, int* value);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_frame_optional_config_set_f)(int unit, int port, cprimod_rsvd4_tx_config_field_t field, int value);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_frame_optional_config_get_f)(int unit, int port, cprimod_rsvd4_tx_config_field_t field, int* value);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_fsm_state_set_f)(int unit, int port, cprimod_rsvd4_tx_fsm_state_t state);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_fsm_state_get_f)(int unit, int port, cprimod_rsvd4_tx_fsm_state_t* state);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_overide_set_f)(int unit, int port, cprimod_rsvd4_tx_overide_t parameter, int enable, int value);
typedef int (*__dispatch__cprimod_port_rsvd4_tx_overide_get_f)(int unit, int port, cprimod_rsvd4_tx_overide_t parameter, int* enable, int* value);
typedef int (*__dispatch__cprimod_port_rx_pcs_status_get_f)(int unit, int port, cprimod_rx_pcs_status_t status, uint32* value);
typedef int (*__dispatch__cprimod_core_init_f)(int unit, int port, const phymod_core_access_t* phy, const phymod_core_init_config_t* init_config, phymod_core_status_t* core_status);
typedef int (*__dispatch__cprimod_port_init_f)(int unit, int port, const phymod_phy_access_t* phy, const cprimod_port_init_config_t* port_config);
typedef int (*__dispatch__cprimod_rsvd4_rx_master_frame_sync_config_set_f)(int unit, int port, uint32 master_frame_number, uint64 master_frame_start_time);
typedef int (*__dispatch__cprimod_rsvd4_rx_master_frame_sync_config_get_f)(int unit, int port, uint32* master_frame_number, uint64* master_frame_start_time);
typedef int (*__dispatch__cprimod_cpri_rx_control_word_sync_info_get_f)(int unit, int port, uint32* basic_frame_num, uint32* hyper_frame_num, uint32* radio_frame_num);
typedef int (*__dispatch__cprimod_cpri_rx_control_word_l1_signal_info_get_f)(int unit, int port, cprimod_cpri_cw_l1_protocol_info_t* l1_info);
typedef int (*__dispatch__cprimod_cpri_rx_control_word_l1_signal_signal_protection_set_f)(int unit, int port, uint32 signal_map, uint32 enable);
typedef int (*__dispatch__cprimod_cpri_rx_control_word_l1_signal_signal_protection_get_f)(int unit, int port, uint32 signal_map, uint32* enable);
typedef int (*__dispatch__cprimod_cpri_port_cw_slow_hdlc_config_set_f)(int unit, int port, const cprimod_slow_hdlc_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_cw_slow_hdlc_config_get_f)(int unit, int port, cprimod_slow_hdlc_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_cw_fast_eth_config_set_f)(int unit, int port, const cprimod_fast_eth_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_cw_fast_eth_config_get_f)(int unit, int port, cprimod_fast_eth_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_vsd_cw_config_set_f)(int unit, int port, const cprimod_cpri_rx_vsd_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_vsd_cw_config_get_f)(int unit, int port, cprimod_cpri_rx_vsd_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_vsd_ctrl_flow_add_f)(int unit, int port, uint32 group_id, const cprimod_cpri_rx_vsd_flow_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_vsd_ctrl_flow_get_f)(int unit, int port, uint32 group_id, cprimod_cpri_rx_vsd_flow_info_t* config_info);
typedef int (*__dispatch__cprimod_encap_control_queue_tag_to_flow_id_map_set_f)(int unit, int port, uint32 tag_id, uint32 flow_id);
typedef int (*__dispatch__cprimod_encap_control_queue_tag_to_flow_id_map_get_f)(int unit, int port, uint32 tag_id, uint32* flow_id);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_cw_config_set_f)(int unit, int port, const cprimod_cpri_tx_vsd_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_cw_config_get_f)(int unit, int port, cprimod_cpri_tx_vsd_config_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_ctrl_flow_add_f)(int unit, int port, uint32 group_id, const cprimod_cpri_tx_vsd_flow_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_ctrl_flow_get_f)(int unit, int port, uint32 group_id, cprimod_cpri_tx_vsd_flow_info_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_vsd_raw_config_set_f)(int unit, int port, uint32 index, const cprimod_cpri_rx_vsd_raw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_vsd_raw_config_get_f)(int unit, int port, uint32 index, cprimod_cpri_rx_vsd_raw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_raw_config_set_f)(int unit, int port, uint32 index, const cprimod_cpri_tx_vsd_raw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_raw_config_get_f)(int unit, int port, uint32 index, cprimod_cpri_tx_vsd_raw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_raw_filter_set_f)(int unit, int port, uint32 bfn0_value, uint32 bfn0_mask, uint32 bfn1_value, uint32 bfn1_mask);
typedef int (*__dispatch__cprimod_cpri_port_tx_vsd_raw_filter_get_f)(int unit, int port, uint32* bfn0_value, uint32* bfn0_mask, uint32* bfn1_value, uint32* bfn1_mask);
typedef int (*__dispatch__cprimod_cpri_port_rx_brcm_rsvd5_control_config_set_f)(int unit, int port, uint32 schan_start, uint32 schan_size, uint32 queue_num, int parity_disable);
typedef int (*__dispatch__cprimod_cpri_port_rx_brcm_rsvd5_control_config_get_f)(int unit, int port, uint32* schan_start, uint32* schan_size, uint32* queue_num, int* parity_disable);
typedef int (*__dispatch__cprimod_cpri_port_tx_brcm_rsvd5_control_config_set_f)(int unit, int port, uint32 schan_start, uint32 schan_size, uint32 queue_num, int crc_enable);
typedef int (*__dispatch__cprimod_cpri_port_tx_brcm_rsvd5_control_config_get_f)(int unit, int port, uint32* schan_start, uint32* schan_size, uint32* queue_num, int* crc_enable);
typedef int (*__dispatch__cprimod_cpri_port_rx_gcw_config_set_f)(int unit, int port, uint32 index, const cprimod_cpri_rx_gcw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_rx_gcw_config_get_f)(int unit, int port, uint32 index, cprimod_cpri_rx_gcw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_gcw_config_set_f)(int unit, int port, uint32 index, const cprimod_cpri_tx_gcw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_gcw_config_get_f)(int unit, int port, uint32 index, cprimod_cpri_tx_gcw_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_port_tx_gcw_filter_set_f)(int unit, int port, uint32 bfn0_value, uint32 bfn0_mask, uint32 bfn1_value, uint32 bfn1_mask);
typedef int (*__dispatch__cprimod_cpri_port_tx_gcw_filter_get_f)(int unit, int port, uint32* bfn0_value, uint32* bfn0_mask, uint32* bfn1_value, uint32* bfn1_mask);
typedef int (*__dispatch__cprimod_cpri_port_tx_control_word_set_f)(int unit, int port, const cprimod_cpri_cw_l1_config_info_t* control_info);
typedef int (*__dispatch__cprimod_rsvd4_rx_control_message_config_set_f)(int unit, int port, uint32 queue_num, uint32 default_tag, uint32 no_match_tag);
typedef int (*__dispatch__cprimod_rsvd4_rx_control_flow_config_set_f)(int unit, int port, uint32 flow_id, const cprimod_control_flow_config_t* config);
typedef int (*__dispatch__cprimod_rsvd4_rx_control_flow_config_get_f)(int unit, int port, uint32 flow_id, cprimod_control_flow_config_t* config);
typedef int (*__dispatch__cprimod_rsvd4_rx_sync_profile_entry_set_f)(int unit, int port, uint32 profile_id, const cprimod_sync_profile_entry_t* entry);
typedef int (*__dispatch__cprimod_rsvd4_rx_sync_profile_entry_get_f)(int unit, int port, uint32 profile_id, cprimod_sync_profile_entry_t* entry);
typedef int (*__dispatch__cprimod_rx_tag_config_set_f)(int unit, int port, uint32 default_tag, uint32 no_match_tag);
typedef int (*__dispatch__cprimod_rx_tag_gen_entry_add_f)(int unit, int port, const cprimod_tag_gen_entry_t* entry);
typedef int (*__dispatch__cprimod_rx_tag_gen_entry_delete_f)(int unit, int port, const cprimod_tag_gen_entry_t* entry);
typedef int (*__dispatch__cprimod_rx_control_flow_tag_option_set_f)(int unit, int port, uint32 flow_id, cprimod_cpri_tag_option_t tag_option);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_flow_group_member_add_f)(int unit, int port, uint32 group_id, uint32 priority, uint32 queue_num, cprimod_control_msg_proc_type_t proc_type);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_flow_group_member_delete_f)(int unit, int port, uint32 group_id, uint32 priority);
typedef int (*__dispatch__cprimod_rsvd4_tx_eth_message_config_set_f)(int unit, int port, uint32 msg_node, uint32 msg_subnode, uint32 msg_type, uint32 msg_padding);
typedef int (*__dispatch__cprimod_rsvd4_tx_single_raw_message_config_set_f)(int unit, int port, uint32 msg_id, uint32 msg_type);
typedef int (*__dispatch__cprimod_rsvd4_tx_single_tunnel_message_config_set_f)(int unit, int port, cprimod_cpri_crc_option_t crc_option);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_flow_config_set_f)(int unit, int port, uint32 flow_id, const cprimod_rsvd4_tx_config_info_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_flow_config_get_f)(int unit, int port, uint32 flow_id, cprimod_rsvd4_tx_config_info_t* config_info);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_flow_header_index_set_f)(int unit, int port, uint32 roe_flow_id, uint32 index);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_flow_header_index_get_f)(int unit, int port, uint32 roe_flow_id, uint32* index);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_header_entry_set_f)(int unit, int port, uint32 index, uint32 header_node, uint32 header_subnode, uint32 payload_node);
typedef int (*__dispatch__cprimod_rsvd4_tx_control_header_entry_get_f)(int unit, int port, uint32 index, uint32* header_node, uint32* header_subnode, uint32* payload_node);
typedef int (*__dispatch__cprimod_rsvd4_fast_eth_config_set_f)(int unit, int port, const cprimod_cpri_fast_eth_config_t* config_info);
typedef int (*__dispatch__cprimod_cpri_or_enet_port_set_f)(int unit, int port, int val);
typedef int (*__dispatch__cprimod_cpri_or_enet_port_get_f)(int unit, int port, int* val);
typedef int (*__dispatch__cprimod_cpri_port_rx_enable_set_f)(int unit, int port, int val);
typedef int (*__dispatch__cprimod_cpri_port_rx_enable_get_f)(int unit, int port, int* val);
typedef int (*__dispatch__cprimod_cpri_port_tx_enable_set_f)(int unit, int port, int val);
typedef int (*__dispatch__cprimod_cpri_port_tx_enable_get_f)(int unit, int port, int* val);
typedef int (*__dispatch__cprimod_cpri_port_interrupt_link_status_get_f)(int unit, int port, const int* is_link_intr_status);
typedef int (*__dispatch__cprimod_cpri_port_interrupt_enable_set_f)(int unit, int port, cprimod_cpri_port_intr_type_t cpri_intr_type, int data, int enable);
typedef int (*__dispatch__cprimod_cpri_port_interrupt_process_f)(int unit, int port);
typedef int (*__dispatch__cprimod_fast_clk_bit_time_period_set_f)(int unit, int port, cprimod_port_speed_t speed);
typedef int (*__dispatch__cprimod_fast_clk_bit_time_period_get_f)(int unit, int port, uint32* bit_time_period);
typedef int (*__dispatch__cprimod_1588_bit_time_period_set_f)(int unit, int port, cprimod_direction_t direction, cprimod_port_speed_t speed);
typedef int (*__dispatch__cprimod_1588_bit_time_period_get_f)(int unit, int port, cprimod_direction_t direction, uint32* bit_time_period);
typedef int (*__dispatch__cprimod_1588_timestamp_capture_config_set_f)(int unit, int port, cprimod_direction_t direction, const cprimod_1588_capture_config_t* config);
typedef int (*__dispatch__cprimod_1588_timestamp_capture_config_get_f)(int unit, int port, cprimod_direction_t direction, cprimod_1588_capture_config_t* config);
typedef int (*__dispatch__cprimod_1588_captured_timestamp_get_f)(int unit, int port, cprimod_direction_t direction, uint8 fifo0_sw1, uint8 mx_cnt, uint8* count, uint64* captured_time);
typedef int (*__dispatch__cprimod_1588_timestamp_adjust_set_f)(int unit, int port, cprimod_direction_t direction, const cprimod_1588_time_t* adjust_time);
typedef int (*__dispatch__cprimod_1588_timestamp_adjust_get_f)(int unit, int port, cprimod_direction_t direction, cprimod_1588_time_t* adjust_time);
typedef int (*__dispatch__cprimod_1588_timestamp_fifo_config_set_f)(int unit, int port, cprimod_direction_t direction, uint16 modulo);
typedef int (*__dispatch__cprimod_1588_timestamp_fifo_config_get_f)(int unit, int port, cprimod_direction_t direction, uint16* modulo);
typedef int (*__dispatch__cprimod_1588_timestamp_cmic_config_set_f)(int unit, int port, cprimod_direction_t direction, uint16 modulo);
typedef int (*__dispatch__cprimod_1588_timestamp_cmic_config_get_f)(int unit, int port, cprimod_direction_t direction, uint16* modulo);
typedef int (*__dispatch__cprimod_cpri_basic_frame_info_get_f)(int unit, int port, cprimod_direction_t dir, uint32* frame_len_in_bits, uint32* control_word_len_in_bits);
typedef int (*__dispatch__cprimod_cpri_agnostic_mode_basic_frame_config_set_f)(int unit, int port, cprimod_direction_t dir, int enable);
typedef int (*__dispatch__cprimod_encap_presentation_time_enable_set_f)(int unit, int port, int enable);
typedef int (*__dispatch__cprimod_encap_presentation_time_enable_get_f)(int unit, int port, int* enable);
typedef int (*__dispatch__cprimod_encap_presentation_time_config_set_f)(int unit, int port, const cprimod_encap_presentation_time_config_t* config);
typedef int (*__dispatch__cprimod_encap_presentation_time_config_get_f)(int unit, int port, cprimod_encap_presentation_time_config_t* config);
typedef int (*__dispatch__cprimod_encap_presentation_time_adjust_set_f)(int unit, int port, uint32 time);
typedef int (*__dispatch__cprimod_encap_presentation_time_adjust_get_f)(int unit, int port, uint32* time);
typedef int (*__dispatch__cprimod_encap_presentation_time_approximate_increment_set_f)(int unit, int port, uint32 time);
typedef int (*__dispatch__cprimod_encap_presentation_time_approximate_increment_get_f)(int unit, int port, uint32* time);
typedef int (*__dispatch__cprimod_decap_agnostic_mode_enable_set_f)(int unit, int port, int enable);
typedef int (*__dispatch__cprimod_decap_agnostic_mode_enable_get_f)(int unit, int port, int* enable);
typedef int (*__dispatch__cprimod_decap_agnostic_mode_config_set_f)(int unit, int port, const cprimod_decap_agnostic_mode_config_t* config);
typedef int (*__dispatch__cprimod_decap_agnostic_mode_config_get_f)(int unit, int port, cprimod_decap_agnostic_mode_config_t* config);
typedef int (*__dispatch__cprimod_decap_presentation_time_config_set_f)(int unit, int port, uint32 mod_offset, uint32 mod_count);
typedef int (*__dispatch__cprimod_decap_presentation_time_config_get_f)(int unit, int port, uint32* mod_offset, uint32* mod_count);
typedef int (*__dispatch__cprimod_compression_lookup_table_set_f)(int unit, int port, int table_depth, const uint32* table);
typedef int (*__dispatch__cprimod_compression_lookup_table_get_f)(int unit, int port, int max_depth, int* table_depth, uint32* table);
typedef int (*__dispatch__cprimod_decompression_lookup_table_set_f)(int unit, int port, int table_depth, const uint32* table);
typedef int (*__dispatch__cprimod_decompression_lookup_table_get_f)(int unit, int port, int max_depth, int* table_depth, uint32* table);
typedef int (*__dispatch__cprimod_cpri_port_decap_queue_flow_control_set_f)(int unit, int port, uint32 queue_num, int enable, uint32_t xon_threshold, uint32_t xoff_threshold);
typedef int (*__dispatch__cprimod_cpri_port_decap_queue_flow_control_get_f)(int unit, int port, uint32 queue_num, int* enable, uint32_t* xon_threshold, uint32_t* xoff_threshold);
typedef int (*__dispatch__cprimod_cpri_port_fec_enable_set_f)(int unit, int port, cprimod_direction_t dir, int enable);
typedef int (*__dispatch__cprimod_cpri_port_fec_enable_get_f)(int unit, int port, cprimod_direction_t dir, int* enable);
typedef int (*__dispatch__cprimod_cpri_port_fec_timestamp_config_set_f)(int unit, int port, cprimod_direction_t dir, const cprimod_fec_timestamp_config_t* config);
typedef int (*__dispatch__cprimod_cpri_port_fec_timestamp_config_get_f)(int unit, int port, cprimod_direction_t dir, const cprimod_fec_timestamp_config_t* config);
typedef int (*__dispatch__cprimod_cpri_port_fec_aux_config_set_f)(int unit, int port, cprimod_fec_aux_config_para_t parameter_id, uint32 value);
typedef int (*__dispatch__cprimod_cpri_port_fec_aux_config_get_f)(int unit, int port, cprimod_fec_aux_config_para_t parameter_id, const uint32* value);
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__cprimod_cpri_port_ecc_interrupt_enable_set_f)(int unit, int port, int enable);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
typedef int (*__dispatch__cprimod_cpri_port_ecc_interrupt_status_get_f)(int unit, int port, const cprimod_cpri_ecc_intr_info_t* ecc_err_info);
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT_ECC_INJECT
typedef int (*__dispatch__cprimod_cpri_port_ecc_interrupt_test_f)(int unit, int port);
#endif /* CPRIMOD_SUPPORT_ECC_INJECT */
typedef int (*__dispatch__cprimod_cpri_pll_status_get_f)(int unit, int port, const phymod_phy_access_t* phy, int* pll_sel, int* pll_lock);
typedef int (*__dispatch__cprimod_cpri_port_reset_set_f)(int unit, int port, int rst);
typedef int (*__dispatch__cprimod_cpri_port_reset_get_f)(int unit, int port, int* rst);
typedef int (*__dispatch__cprimod_cpri_init_f)(int unit, int port);
typedef int (*__dispatch__cprimod_cpri_port_rx_gcw_word_get_f)(int unit, int port, int group_index, uint16* gcw_word);
typedef int (*__dispatch__cprimod_cpri_port_tx_gcw_word_set_f)(int unit, int port, int group_index, uint16 gcw_word);
typedef int (*__dispatch__cprimod_cpri_mac_drain_start_f)(int unit, int port);
typedef int (*__dispatch__cprimod_cpri_mac_drain_stop_f)(int unit, int port);
typedef int (*__dispatch__cprimod_cpri_mac_credit_reset_set_f)(int unit, int port, int rst);
typedef int (*__dispatch__cprimod_cpri_mac_credit_reset_get_f)(int unit, int port, int* rst);
typedef int (*__dispatch__cprimod_cpri_port_link_down_event_f)(int unit, int port);

typedef struct __cprimod__dispatch__s__ {
    __dispatch__cprimod_test_api_dispatch_f                                          f_cprimod_test_api_dispatch;
    __dispatch__cprimod_basic_frame_parser_active_table_set_f                        f_cprimod_basic_frame_parser_active_table_set;
    __dispatch__cprimod_basic_frame_parser_active_table_get_f                        f_cprimod_basic_frame_parser_active_table_get;
    __dispatch__cprimod_basic_frame_parser_table_num_entries_set_f                   f_cprimod_basic_frame_parser_table_num_entries_set;
    __dispatch__cprimod_basic_frame_parser_table_num_entries_get_f                   f_cprimod_basic_frame_parser_table_num_entries_get;
    __dispatch__cprimod_basic_frame_assembly_active_table_set_f                      f_cprimod_basic_frame_assembly_active_table_set;
    __dispatch__cprimod_basic_frame_assembly_active_table_get_f                      f_cprimod_basic_frame_assembly_active_table_get;
    __dispatch__cprimod_basic_frame_assembly_table_num_entries_set_f                 f_cprimod_basic_frame_assembly_table_num_entries_set;
    __dispatch__cprimod_basic_frame_assembly_table_num_entries_get_f                 f_cprimod_basic_frame_assembly_table_num_entries_get;
    __dispatch__cprimod_rx_axc_basic_frame_add_f                                     f_cprimod_rx_axc_basic_frame_add;
    __dispatch__cprimod_rx_axc_basic_frame_delete_f                                  f_cprimod_rx_axc_basic_frame_delete;
    __dispatch__cprimod_rx_axc_basic_frame_clear_f                                   f_cprimod_rx_axc_basic_frame_clear;
    __dispatch__cprimod_rx_axc_basic_frame_get_f                                     f_cprimod_rx_axc_basic_frame_get;
    __dispatch__cprimod_tx_axc_basic_frame_add_f                                     f_cprimod_tx_axc_basic_frame_add;
    __dispatch__cprimod_tx_axc_basic_frame_delete_f                                  f_cprimod_tx_axc_basic_frame_delete;
    __dispatch__cprimod_tx_axc_basic_frame_clear_f                                   f_cprimod_tx_axc_basic_frame_clear;
    __dispatch__cprimod_tx_axc_basic_frame_get_f                                     f_cprimod_tx_axc_basic_frame_get;
    __dispatch__cprimod_basic_frame_debug_f                                          f_cprimod_basic_frame_debug;
    __dispatch__cprimod_cpri_rx_axc_container_config_set_f                           f_cprimod_cpri_rx_axc_container_config_set;
    __dispatch__cprimod_cpri_rx_axc_container_config_get_f                           f_cprimod_cpri_rx_axc_container_config_get;
    __dispatch__cprimod_cpri_tx_axc_container_config_set_f                           f_cprimod_cpri_tx_axc_container_config_set;
    __dispatch__cprimod_cpri_tx_axc_container_config_get_f                           f_cprimod_cpri_tx_axc_container_config_get;
    __dispatch__cprimod_rsvd4_rx_axc_container_config_set_f                          f_cprimod_rsvd4_rx_axc_container_config_set;
    __dispatch__cprimod_rsvd4_rx_axc_container_config_get_f                          f_cprimod_rsvd4_rx_axc_container_config_get;
    __dispatch__cprimod_rsvd4_tx_axc_container_config_set_f                          f_cprimod_rsvd4_tx_axc_container_config_set;
    __dispatch__cprimod_rsvd4_tx_axc_container_config_get_f                          f_cprimod_rsvd4_tx_axc_container_config_get;
    __dispatch__cprimod_rx_roe_payload_size_set_f                                    f_cprimod_rx_roe_payload_size_set;
    __dispatch__cprimod_rx_roe_payload_size_get_f                                    f_cprimod_rx_roe_payload_size_get;
    __dispatch__cprimod_tx_roe_payload_size_set_f                                    f_cprimod_tx_roe_payload_size_set;
    __dispatch__cprimod_tx_roe_payload_size_get_f                                    f_cprimod_tx_roe_payload_size_get;
    __dispatch__cprimod_cpri_encap_data_config_set_f                                 f_cprimod_cpri_encap_data_config_set;
    __dispatch__cprimod_cpri_encap_data_config_get_f                                 f_cprimod_cpri_encap_data_config_get;
    __dispatch__cprimod_cpri_decap_data_config_set_f                                 f_cprimod_cpri_decap_data_config_set;
    __dispatch__cprimod_cpri_decap_data_config_get_f                                 f_cprimod_cpri_decap_data_config_get;
    __dispatch__cprimod_rsvd4_encap_data_config_set_f                                f_cprimod_rsvd4_encap_data_config_set;
    __dispatch__cprimod_rsvd4_encap_data_config_get_f                                f_cprimod_rsvd4_encap_data_config_get;
    __dispatch__cprimod_rsvd4_decap_data_config_set_f                                f_cprimod_rsvd4_decap_data_config_set;
    __dispatch__cprimod_rsvd4_decap_data_config_get_f                                f_cprimod_rsvd4_decap_data_config_get;
    __dispatch__cprimod_encap_header_config_set_f                                    f_cprimod_encap_header_config_set;
    __dispatch__cprimod_encap_header_config_get_f                                    f_cprimod_encap_header_config_get;
    __dispatch__cprimod_rx_rsvd4_gsm_tsn_bitmap_set_f                                f_cprimod_rx_rsvd4_gsm_tsn_bitmap_set;
    __dispatch__cprimod_rx_rsvd4_gsm_tsn_bitmap_get_f                                f_cprimod_rx_rsvd4_gsm_tsn_bitmap_get;
    __dispatch__cprimod_encap_ordering_info_entry_set_f                              f_cprimod_encap_ordering_info_entry_set;
    __dispatch__cprimod_encap_ordering_info_entry_get_f                              f_cprimod_encap_ordering_info_entry_get;
    __dispatch__cprimod_decap_ordering_info_entry_set_f                              f_cprimod_decap_ordering_info_entry_set;
    __dispatch__cprimod_decap_ordering_info_entry_get_f                              f_cprimod_decap_ordering_info_entry_get;
    __dispatch__cprimod_encap_ordering_info_sequence_offset_set_f                    f_cprimod_encap_ordering_info_sequence_offset_set;
    __dispatch__cprimod_encap_ordering_info_sequence_offset_get_f                    f_cprimod_encap_ordering_info_sequence_offset_get;
    __dispatch__cprimod_decap_ordering_info_sequence_offset_set_f                    f_cprimod_decap_ordering_info_sequence_offset_set;
    __dispatch__cprimod_decap_ordering_info_sequence_offset_get_f                    f_cprimod_decap_ordering_info_sequence_offset_get;
    __dispatch__cprimod_encap_mac_da_entry_set_f                                     f_cprimod_encap_mac_da_entry_set;
    __dispatch__cprimod_encap_mac_da_entry_get_f                                     f_cprimod_encap_mac_da_entry_get;
    __dispatch__cprimod_encap_mac_sa_entry_set_f                                     f_cprimod_encap_mac_sa_entry_set;
    __dispatch__cprimod_encap_mac_sa_entry_get_f                                     f_cprimod_encap_mac_sa_entry_get;
    __dispatch__cprimod_encap_vlan_id_entry_set_f                                    f_cprimod_encap_vlan_id_entry_set;
    __dispatch__cprimod_encap_vlan_id_entry_get_f                                    f_cprimod_encap_vlan_id_entry_get;
    __dispatch__cprimod_decap_ethertype_config_set_f                                 f_cprimod_decap_ethertype_config_set;
    __dispatch__cprimod_decap_ethertype_config_get_f                                 f_cprimod_decap_ethertype_config_get;
    __dispatch__cprimod_encap_ethertype_config_set_f                                 f_cprimod_encap_ethertype_config_set;
    __dispatch__cprimod_encap_ethertype_config_get_f                                 f_cprimod_encap_ethertype_config_get;
    __dispatch__cprimod_encap_memory_clear_f                                         f_cprimod_encap_memory_clear;
    __dispatch__cprimod_cpri_rx_framer_state_clear_f                                 f_cprimod_cpri_rx_framer_state_clear;
    __dispatch__cprimod_decap_memory_clear_f                                         f_cprimod_decap_memory_clear;
    __dispatch__cprimod_cpri_tx_framer_state_clear_f                                 f_cprimod_cpri_tx_framer_state_clear;
    __dispatch__cprimod_decap_flow_classification_config_set_f                       f_cprimod_decap_flow_classification_config_set;
    __dispatch__cprimod_decap_flow_classification_config_get_f                       f_cprimod_decap_flow_classification_config_get;
    __dispatch__cprimod_decap_flow_to_queue_mapping_set_f                            f_cprimod_decap_flow_to_queue_mapping_set;
    __dispatch__cprimod_decap_flow_to_queue_mapping_get_f                            f_cprimod_decap_flow_to_queue_mapping_get;
    __dispatch__cprimod_decap_queue_to_ordering_info_index_mapping_set_f             f_cprimod_decap_queue_to_ordering_info_index_mapping_set;
    __dispatch__cprimod_decap_queue_to_ordering_info_index_mapping_get_f             f_cprimod_decap_queue_to_ordering_info_index_mapping_get;
    __dispatch__cprimod_tx_framer_tgen_tick_set_f                                    f_cprimod_tx_framer_tgen_tick_set;
    __dispatch__cprimod_tx_framer_tgen_tick_get_f                                    f_cprimod_tx_framer_tgen_tick_get;
    __dispatch__cprimod_tx_framer_tgen_enable_f                                      f_cprimod_tx_framer_tgen_enable;
    __dispatch__cprimod_tx_framer_tgen_offset_set_f                                  f_cprimod_tx_framer_tgen_offset_set;
    __dispatch__cprimod_tx_framer_tgen_offset_get_f                                  f_cprimod_tx_framer_tgen_offset_get;
    __dispatch__cprimod_tx_framer_tgen_next_bfn_set_f                                f_cprimod_tx_framer_tgen_next_bfn_set;
    __dispatch__cprimod_tx_framer_tgen_next_bfn_get_f                                f_cprimod_tx_framer_tgen_next_bfn_get;
    __dispatch__cprimod_tx_framer_tgen_next_hfn_set_f                                f_cprimod_tx_framer_tgen_next_hfn_set;
    __dispatch__cprimod_tx_framer_tgen_next_hfn_get_f                                f_cprimod_tx_framer_tgen_next_hfn_get;
    __dispatch__cprimod_tx_framer_tgen_select_counter_set_f                          f_cprimod_tx_framer_tgen_select_counter_set;
    __dispatch__cprimod_tx_framer_tgen_select_counter_get_f                          f_cprimod_tx_framer_tgen_select_counter_get;
    __dispatch__cprimod_header_compare_entry_add_f                                   f_cprimod_header_compare_entry_add;
    __dispatch__cprimod_header_compare_entry_delete_f                                f_cprimod_header_compare_entry_delete;
    __dispatch__cprimod_header_compare_entry_for_flow_delete_f                       f_cprimod_header_compare_entry_for_flow_delete;
    __dispatch__cprimod_modulo_rule_entry_set_f                                      f_cprimod_modulo_rule_entry_set;
    __dispatch__cprimod_modulo_rule_entry_get_f                                      f_cprimod_modulo_rule_entry_get;
    __dispatch__cprimod_dual_bitmap_rule_entry_set_f                                 f_cprimod_dual_bitmap_rule_entry_set;
    __dispatch__cprimod_dual_bitmap_rule_entry_get_f                                 f_cprimod_dual_bitmap_rule_entry_get;
    __dispatch__cprimod_secondary_dual_bitmap_rule_entry_set_f                       f_cprimod_secondary_dual_bitmap_rule_entry_set;
    __dispatch__cprimod_secondary_dual_bitmap_rule_entry_get_f                       f_cprimod_secondary_dual_bitmap_rule_entry_get;
    __dispatch__cprimod_dbm_position_entry_set_f                                     f_cprimod_dbm_position_entry_set;
    __dispatch__cprimod_dbm_position_entry_get_f                                     f_cprimod_dbm_position_entry_get;
    __dispatch__cprimod_port_rx_interface_config_set_f                               f_cprimod_port_rx_interface_config_set;
    __dispatch__cprimod_port_rx_interface_config_get_f                               f_cprimod_port_rx_interface_config_get;
    __dispatch__cprimod_port_tx_interface_config_set_f                               f_cprimod_port_tx_interface_config_set;
    __dispatch__cprimod_port_tx_interface_config_get_f                               f_cprimod_port_tx_interface_config_get;
    __dispatch__cprimod_port_rsvd4_rx_config_set_f                                   f_cprimod_port_rsvd4_rx_config_set;
    __dispatch__cprimod_port_rsvd4_rx_config_get_f                                   f_cprimod_port_rsvd4_rx_config_get;
    __dispatch__cprimod_port_rsvd4_tx_config_set_f                                   f_cprimod_port_rsvd4_tx_config_set;
    __dispatch__cprimod_port_rsvd4_tx_config_get_f                                   f_cprimod_port_rsvd4_tx_config_get;
    __dispatch__cprimod_port_rx_frame_optional_config_set_f                          f_cprimod_port_rx_frame_optional_config_set;
    __dispatch__cprimod_port_rx_frame_optional_config_get_f                          f_cprimod_port_rx_frame_optional_config_get;
    __dispatch__cprimod_port_tx_frame_optional_config_set_f                          f_cprimod_port_tx_frame_optional_config_set;
    __dispatch__cprimod_port_tx_frame_optional_config_get_f                          f_cprimod_port_tx_frame_optional_config_get;
    __dispatch__cprimod_port_rsvd4_rx_frame_optional_config_set_f                    f_cprimod_port_rsvd4_rx_frame_optional_config_set;
    __dispatch__cprimod_port_rsvd4_rx_frame_optional_config_get_f                    f_cprimod_port_rsvd4_rx_frame_optional_config_get;
    __dispatch__cprimod_port_rsvd4_rx_speed_set_f                                    f_cprimod_port_rsvd4_rx_speed_set;
    __dispatch__cprimod_port_rsvd4_rx_speed_get_f                                    f_cprimod_port_rsvd4_rx_speed_get;
    __dispatch__cprimod_port_rsvd4_tx_speed_set_f                                    f_cprimod_port_rsvd4_tx_speed_set;
    __dispatch__cprimod_port_rsvd4_tx_speed_get_f                                    f_cprimod_port_rsvd4_tx_speed_get;
    __dispatch__cprimod_port_rsvd4_rx_fsm_state_set_f                                f_cprimod_port_rsvd4_rx_fsm_state_set;
    __dispatch__cprimod_port_rsvd4_rx_fsm_state_get_f                                f_cprimod_port_rsvd4_rx_fsm_state_get;
    __dispatch__cprimod_port_rsvd4_rx_overide_set_f                                  f_cprimod_port_rsvd4_rx_overide_set;
    __dispatch__cprimod_port_rsvd4_rx_overide_get_f                                  f_cprimod_port_rsvd4_rx_overide_get;
    __dispatch__cprimod_port_rsvd4_tx_frame_optional_config_set_f                    f_cprimod_port_rsvd4_tx_frame_optional_config_set;
    __dispatch__cprimod_port_rsvd4_tx_frame_optional_config_get_f                    f_cprimod_port_rsvd4_tx_frame_optional_config_get;
    __dispatch__cprimod_port_rsvd4_tx_fsm_state_set_f                                f_cprimod_port_rsvd4_tx_fsm_state_set;
    __dispatch__cprimod_port_rsvd4_tx_fsm_state_get_f                                f_cprimod_port_rsvd4_tx_fsm_state_get;
    __dispatch__cprimod_port_rsvd4_tx_overide_set_f                                  f_cprimod_port_rsvd4_tx_overide_set;
    __dispatch__cprimod_port_rsvd4_tx_overide_get_f                                  f_cprimod_port_rsvd4_tx_overide_get;
    __dispatch__cprimod_port_rx_pcs_status_get_f                                     f_cprimod_port_rx_pcs_status_get;
    __dispatch__cprimod_core_init_f                                                  f_cprimod_core_init;
    __dispatch__cprimod_port_init_f                                                  f_cprimod_port_init;
    __dispatch__cprimod_rsvd4_rx_master_frame_sync_config_set_f                      f_cprimod_rsvd4_rx_master_frame_sync_config_set;
    __dispatch__cprimod_rsvd4_rx_master_frame_sync_config_get_f                      f_cprimod_rsvd4_rx_master_frame_sync_config_get;
    __dispatch__cprimod_cpri_rx_control_word_sync_info_get_f                         f_cprimod_cpri_rx_control_word_sync_info_get;
    __dispatch__cprimod_cpri_rx_control_word_l1_signal_info_get_f                    f_cprimod_cpri_rx_control_word_l1_signal_info_get;
    __dispatch__cprimod_cpri_rx_control_word_l1_signal_signal_protection_set_f       f_cprimod_cpri_rx_control_word_l1_signal_signal_protection_set;
    __dispatch__cprimod_cpri_rx_control_word_l1_signal_signal_protection_get_f       f_cprimod_cpri_rx_control_word_l1_signal_signal_protection_get;
    __dispatch__cprimod_cpri_port_cw_slow_hdlc_config_set_f                          f_cprimod_cpri_port_cw_slow_hdlc_config_set;
    __dispatch__cprimod_cpri_port_cw_slow_hdlc_config_get_f                          f_cprimod_cpri_port_cw_slow_hdlc_config_get;
    __dispatch__cprimod_cpri_port_cw_fast_eth_config_set_f                           f_cprimod_cpri_port_cw_fast_eth_config_set;
    __dispatch__cprimod_cpri_port_cw_fast_eth_config_get_f                           f_cprimod_cpri_port_cw_fast_eth_config_get;
    __dispatch__cprimod_cpri_port_rx_vsd_cw_config_set_f                             f_cprimod_cpri_port_rx_vsd_cw_config_set;
    __dispatch__cprimod_cpri_port_rx_vsd_cw_config_get_f                             f_cprimod_cpri_port_rx_vsd_cw_config_get;
    __dispatch__cprimod_cpri_port_rx_vsd_ctrl_flow_add_f                             f_cprimod_cpri_port_rx_vsd_ctrl_flow_add;
    __dispatch__cprimod_cpri_port_rx_vsd_ctrl_flow_get_f                             f_cprimod_cpri_port_rx_vsd_ctrl_flow_get;
    __dispatch__cprimod_encap_control_queue_tag_to_flow_id_map_set_f                 f_cprimod_encap_control_queue_tag_to_flow_id_map_set;
    __dispatch__cprimod_encap_control_queue_tag_to_flow_id_map_get_f                 f_cprimod_encap_control_queue_tag_to_flow_id_map_get;
    __dispatch__cprimod_cpri_port_tx_vsd_cw_config_set_f                             f_cprimod_cpri_port_tx_vsd_cw_config_set;
    __dispatch__cprimod_cpri_port_tx_vsd_cw_config_get_f                             f_cprimod_cpri_port_tx_vsd_cw_config_get;
    __dispatch__cprimod_cpri_port_tx_vsd_ctrl_flow_add_f                             f_cprimod_cpri_port_tx_vsd_ctrl_flow_add;
    __dispatch__cprimod_cpri_port_tx_vsd_ctrl_flow_get_f                             f_cprimod_cpri_port_tx_vsd_ctrl_flow_get;
    __dispatch__cprimod_cpri_port_rx_vsd_raw_config_set_f                            f_cprimod_cpri_port_rx_vsd_raw_config_set;
    __dispatch__cprimod_cpri_port_rx_vsd_raw_config_get_f                            f_cprimod_cpri_port_rx_vsd_raw_config_get;
    __dispatch__cprimod_cpri_port_tx_vsd_raw_config_set_f                            f_cprimod_cpri_port_tx_vsd_raw_config_set;
    __dispatch__cprimod_cpri_port_tx_vsd_raw_config_get_f                            f_cprimod_cpri_port_tx_vsd_raw_config_get;
    __dispatch__cprimod_cpri_port_tx_vsd_raw_filter_set_f                            f_cprimod_cpri_port_tx_vsd_raw_filter_set;
    __dispatch__cprimod_cpri_port_tx_vsd_raw_filter_get_f                            f_cprimod_cpri_port_tx_vsd_raw_filter_get;
    __dispatch__cprimod_cpri_port_rx_brcm_rsvd5_control_config_set_f                 f_cprimod_cpri_port_rx_brcm_rsvd5_control_config_set;
    __dispatch__cprimod_cpri_port_rx_brcm_rsvd5_control_config_get_f                 f_cprimod_cpri_port_rx_brcm_rsvd5_control_config_get;
    __dispatch__cprimod_cpri_port_tx_brcm_rsvd5_control_config_set_f                 f_cprimod_cpri_port_tx_brcm_rsvd5_control_config_set;
    __dispatch__cprimod_cpri_port_tx_brcm_rsvd5_control_config_get_f                 f_cprimod_cpri_port_tx_brcm_rsvd5_control_config_get;
    __dispatch__cprimod_cpri_port_rx_gcw_config_set_f                                f_cprimod_cpri_port_rx_gcw_config_set;
    __dispatch__cprimod_cpri_port_rx_gcw_config_get_f                                f_cprimod_cpri_port_rx_gcw_config_get;
    __dispatch__cprimod_cpri_port_tx_gcw_config_set_f                                f_cprimod_cpri_port_tx_gcw_config_set;
    __dispatch__cprimod_cpri_port_tx_gcw_config_get_f                                f_cprimod_cpri_port_tx_gcw_config_get;
    __dispatch__cprimod_cpri_port_tx_gcw_filter_set_f                                f_cprimod_cpri_port_tx_gcw_filter_set;
    __dispatch__cprimod_cpri_port_tx_gcw_filter_get_f                                f_cprimod_cpri_port_tx_gcw_filter_get;
    __dispatch__cprimod_cpri_port_tx_control_word_set_f                              f_cprimod_cpri_port_tx_control_word_set;
    __dispatch__cprimod_rsvd4_rx_control_message_config_set_f                        f_cprimod_rsvd4_rx_control_message_config_set;
    __dispatch__cprimod_rsvd4_rx_control_flow_config_set_f                           f_cprimod_rsvd4_rx_control_flow_config_set;
    __dispatch__cprimod_rsvd4_rx_control_flow_config_get_f                           f_cprimod_rsvd4_rx_control_flow_config_get;
    __dispatch__cprimod_rsvd4_rx_sync_profile_entry_set_f                            f_cprimod_rsvd4_rx_sync_profile_entry_set;
    __dispatch__cprimod_rsvd4_rx_sync_profile_entry_get_f                            f_cprimod_rsvd4_rx_sync_profile_entry_get;
    __dispatch__cprimod_rx_tag_config_set_f                                          f_cprimod_rx_tag_config_set;
    __dispatch__cprimod_rx_tag_gen_entry_add_f                                       f_cprimod_rx_tag_gen_entry_add;
    __dispatch__cprimod_rx_tag_gen_entry_delete_f                                    f_cprimod_rx_tag_gen_entry_delete;
    __dispatch__cprimod_rx_control_flow_tag_option_set_f                             f_cprimod_rx_control_flow_tag_option_set;
    __dispatch__cprimod_rsvd4_tx_control_flow_group_member_add_f                     f_cprimod_rsvd4_tx_control_flow_group_member_add;
    __dispatch__cprimod_rsvd4_tx_control_flow_group_member_delete_f                  f_cprimod_rsvd4_tx_control_flow_group_member_delete;
    __dispatch__cprimod_rsvd4_tx_eth_message_config_set_f                            f_cprimod_rsvd4_tx_eth_message_config_set;
    __dispatch__cprimod_rsvd4_tx_single_raw_message_config_set_f                     f_cprimod_rsvd4_tx_single_raw_message_config_set;
    __dispatch__cprimod_rsvd4_tx_single_tunnel_message_config_set_f                  f_cprimod_rsvd4_tx_single_tunnel_message_config_set;
    __dispatch__cprimod_rsvd4_tx_control_flow_config_set_f                           f_cprimod_rsvd4_tx_control_flow_config_set;
    __dispatch__cprimod_rsvd4_tx_control_flow_config_get_f                           f_cprimod_rsvd4_tx_control_flow_config_get;
    __dispatch__cprimod_rsvd4_tx_control_flow_header_index_set_f                     f_cprimod_rsvd4_tx_control_flow_header_index_set;
    __dispatch__cprimod_rsvd4_tx_control_flow_header_index_get_f                     f_cprimod_rsvd4_tx_control_flow_header_index_get;
    __dispatch__cprimod_rsvd4_tx_control_header_entry_set_f                          f_cprimod_rsvd4_tx_control_header_entry_set;
    __dispatch__cprimod_rsvd4_tx_control_header_entry_get_f                          f_cprimod_rsvd4_tx_control_header_entry_get;
    __dispatch__cprimod_rsvd4_fast_eth_config_set_f                                  f_cprimod_rsvd4_fast_eth_config_set;
    __dispatch__cprimod_cpri_or_enet_port_set_f                                      f_cprimod_cpri_or_enet_port_set;
    __dispatch__cprimod_cpri_or_enet_port_get_f                                      f_cprimod_cpri_or_enet_port_get;
    __dispatch__cprimod_cpri_port_rx_enable_set_f                                    f_cprimod_cpri_port_rx_enable_set;
    __dispatch__cprimod_cpri_port_rx_enable_get_f                                    f_cprimod_cpri_port_rx_enable_get;
    __dispatch__cprimod_cpri_port_tx_enable_set_f                                    f_cprimod_cpri_port_tx_enable_set;
    __dispatch__cprimod_cpri_port_tx_enable_get_f                                    f_cprimod_cpri_port_tx_enable_get;
    __dispatch__cprimod_cpri_port_interrupt_link_status_get_f                        f_cprimod_cpri_port_interrupt_link_status_get;
    __dispatch__cprimod_cpri_port_interrupt_enable_set_f                             f_cprimod_cpri_port_interrupt_enable_set;
    __dispatch__cprimod_cpri_port_interrupt_process_f                                f_cprimod_cpri_port_interrupt_process;
    __dispatch__cprimod_fast_clk_bit_time_period_set_f                               f_cprimod_fast_clk_bit_time_period_set;
    __dispatch__cprimod_fast_clk_bit_time_period_get_f                               f_cprimod_fast_clk_bit_time_period_get;
    __dispatch__cprimod_1588_bit_time_period_set_f                                   f_cprimod_1588_bit_time_period_set;
    __dispatch__cprimod_1588_bit_time_period_get_f                                   f_cprimod_1588_bit_time_period_get;
    __dispatch__cprimod_1588_timestamp_capture_config_set_f                          f_cprimod_1588_timestamp_capture_config_set;
    __dispatch__cprimod_1588_timestamp_capture_config_get_f                          f_cprimod_1588_timestamp_capture_config_get;
    __dispatch__cprimod_1588_captured_timestamp_get_f                                f_cprimod_1588_captured_timestamp_get;
    __dispatch__cprimod_1588_timestamp_adjust_set_f                                  f_cprimod_1588_timestamp_adjust_set;
    __dispatch__cprimod_1588_timestamp_adjust_get_f                                  f_cprimod_1588_timestamp_adjust_get;
    __dispatch__cprimod_1588_timestamp_fifo_config_set_f                             f_cprimod_1588_timestamp_fifo_config_set;
    __dispatch__cprimod_1588_timestamp_fifo_config_get_f                             f_cprimod_1588_timestamp_fifo_config_get;
    __dispatch__cprimod_1588_timestamp_cmic_config_set_f                             f_cprimod_1588_timestamp_cmic_config_set;
    __dispatch__cprimod_1588_timestamp_cmic_config_get_f                             f_cprimod_1588_timestamp_cmic_config_get;
    __dispatch__cprimod_cpri_basic_frame_info_get_f                                  f_cprimod_cpri_basic_frame_info_get;
    __dispatch__cprimod_cpri_agnostic_mode_basic_frame_config_set_f                  f_cprimod_cpri_agnostic_mode_basic_frame_config_set;
    __dispatch__cprimod_encap_presentation_time_enable_set_f                         f_cprimod_encap_presentation_time_enable_set;
    __dispatch__cprimod_encap_presentation_time_enable_get_f                         f_cprimod_encap_presentation_time_enable_get;
    __dispatch__cprimod_encap_presentation_time_config_set_f                         f_cprimod_encap_presentation_time_config_set;
    __dispatch__cprimod_encap_presentation_time_config_get_f                         f_cprimod_encap_presentation_time_config_get;
    __dispatch__cprimod_encap_presentation_time_adjust_set_f                         f_cprimod_encap_presentation_time_adjust_set;
    __dispatch__cprimod_encap_presentation_time_adjust_get_f                         f_cprimod_encap_presentation_time_adjust_get;
    __dispatch__cprimod_encap_presentation_time_approximate_increment_set_f          f_cprimod_encap_presentation_time_approximate_increment_set;
    __dispatch__cprimod_encap_presentation_time_approximate_increment_get_f          f_cprimod_encap_presentation_time_approximate_increment_get;
    __dispatch__cprimod_decap_agnostic_mode_enable_set_f                             f_cprimod_decap_agnostic_mode_enable_set;
    __dispatch__cprimod_decap_agnostic_mode_enable_get_f                             f_cprimod_decap_agnostic_mode_enable_get;
    __dispatch__cprimod_decap_agnostic_mode_config_set_f                             f_cprimod_decap_agnostic_mode_config_set;
    __dispatch__cprimod_decap_agnostic_mode_config_get_f                             f_cprimod_decap_agnostic_mode_config_get;
    __dispatch__cprimod_decap_presentation_time_config_set_f                         f_cprimod_decap_presentation_time_config_set;
    __dispatch__cprimod_decap_presentation_time_config_get_f                         f_cprimod_decap_presentation_time_config_get;
    __dispatch__cprimod_compression_lookup_table_set_f                               f_cprimod_compression_lookup_table_set;
    __dispatch__cprimod_compression_lookup_table_get_f                               f_cprimod_compression_lookup_table_get;
    __dispatch__cprimod_decompression_lookup_table_set_f                             f_cprimod_decompression_lookup_table_set;
    __dispatch__cprimod_decompression_lookup_table_get_f                             f_cprimod_decompression_lookup_table_get;
    __dispatch__cprimod_cpri_port_decap_queue_flow_control_set_f                     f_cprimod_cpri_port_decap_queue_flow_control_set;
    __dispatch__cprimod_cpri_port_decap_queue_flow_control_get_f                     f_cprimod_cpri_port_decap_queue_flow_control_get;
    __dispatch__cprimod_cpri_port_fec_enable_set_f                                   f_cprimod_cpri_port_fec_enable_set;
    __dispatch__cprimod_cpri_port_fec_enable_get_f                                   f_cprimod_cpri_port_fec_enable_get;
    __dispatch__cprimod_cpri_port_fec_timestamp_config_set_f                         f_cprimod_cpri_port_fec_timestamp_config_set;
    __dispatch__cprimod_cpri_port_fec_timestamp_config_get_f                         f_cprimod_cpri_port_fec_timestamp_config_get;
    __dispatch__cprimod_cpri_port_fec_aux_config_set_f                               f_cprimod_cpri_port_fec_aux_config_set;
    __dispatch__cprimod_cpri_port_fec_aux_config_get_f                               f_cprimod_cpri_port_fec_aux_config_get;
#ifdef CPRIMOD_SUPPORT
    __dispatch__cprimod_cpri_port_ecc_interrupt_enable_set_f                         f_cprimod_cpri_port_ecc_interrupt_enable_set;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT
    __dispatch__cprimod_cpri_port_ecc_interrupt_status_get_f                         f_cprimod_cpri_port_ecc_interrupt_status_get;
#endif /* CPRIMOD_SUPPORT */
#ifdef CPRIMOD_SUPPORT_ECC_INJECT
    __dispatch__cprimod_cpri_port_ecc_interrupt_test_f                               f_cprimod_cpri_port_ecc_interrupt_test;
#endif /* CPRIMOD_SUPPORT_ECC_INJECT */
    __dispatch__cprimod_cpri_pll_status_get_f                                        f_cprimod_cpri_pll_status_get;
    __dispatch__cprimod_cpri_port_reset_set_f                                        f_cprimod_cpri_port_reset_set;
    __dispatch__cprimod_cpri_port_reset_get_f                                        f_cprimod_cpri_port_reset_get;
    __dispatch__cprimod_cpri_init_f                                                  f_cprimod_cpri_init;
    __dispatch__cprimod_cpri_port_rx_gcw_word_get_f                                  f_cprimod_cpri_port_rx_gcw_word_get;
    __dispatch__cprimod_cpri_port_tx_gcw_word_set_f                                  f_cprimod_cpri_port_tx_gcw_word_set;
    __dispatch__cprimod_cpri_mac_drain_start_f                                       f_cprimod_cpri_mac_drain_start;
    __dispatch__cprimod_cpri_mac_drain_stop_f                                        f_cprimod_cpri_mac_drain_stop;
    __dispatch__cprimod_cpri_mac_credit_reset_set_f                                  f_cprimod_cpri_mac_credit_reset_set;
    __dispatch__cprimod_cpri_mac_credit_reset_get_f                                  f_cprimod_cpri_mac_credit_reset_get;
    __dispatch__cprimod_cpri_port_link_down_event_f                                  f_cprimod_cpri_port_link_down_event;
} __cprimod__dispatch__t__;

extern __cprimod__dispatch__t__* __cprimod__dispatch__[cprimodDispatchTypeCount];

#endif /*_CPRIMOD_DISPATCH_H_*/
