/*
 * $Id: cancun_enums.h $
 * $Copyright: (c) 2018 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 *
 * File:    cancun_enums.h
 * Purpose: Header file for CANCUN defined enums
 */

#ifndef _CANCUN_ENUMS_H_
#define _CANCUN_ENUMS_H_

/*
 * CANCUN source application IDs
*/
/* CMH Format 2 Application IDs*/
#define CANCUN_APP__PORT_TABLE__MIM_MC_TERM_ENABLE 0
#define CANCUN_APP__SOURCE_VP__Control_Word 1
#define CANCUN_APP__SOURCE_VP__No_Control_Word 2
#define CANCUN_APP__VFI__IPMC_V4_L2_ENABLE 3
#define CANCUN_APP__VFI__IPMC_V4_V6_L2_DISABLE 4
#define CANCUN_APP__VFI__IPMC_V4_V6_L2_ENABLE 5
#define CANCUN_APP__VFI__IPMC_V6_L2_ENABLE 6
/* CMH Format 3 Application IDs*/
#define CANCUN_APP__EGR_HG_MIRROR_EDIT_CTRL_ID__INGRESS_MIRROR_HG_TAG 7
#define CANCUN_APP__EGR_HG_MIRROR_EDIT_CTRL_ID__INGRESS_MIRROR_HG_UNTAG 8
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_EGRESS_MIRROR 9
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_EGRESS_MIRROR_UNTAG_PAYLOAD 10
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_INGRESS_MIRROR 11
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_INGRESS_MIRROR_UNTAG_PAYLOAD 12
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_EGRESS_MIRROR 13
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_EGRESS_MIRROR_UNTAG_PAYLOAD 14
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_INGRESS_MIRROR 15
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_INGRESS_MIRROR_UNTAG_PAYLOAD 16
#define CANCUN_APP__EGR_MIRROR_TABLE__INGRESS_MIRROR_LOCAL_MTP 17
#define CANCUN_APP__EGR_MIRROR_TABLE__INGRESS_MIRROR_REMOTE_MTP 18
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP 19
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_EGRESS_MIRROR 20
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_INGRESS_MIRROR 21
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_INGRESS_MIRROR 22
#define CANCUN_APP__EGR_PORT__CASCADED_PORT 23
#define CANCUN_APP__EGR_PORT__CPU_ETHERNET_PORT 24
#define CANCUN_APP__EGR_PORT__CPU_HG2_PORT 25
#define CANCUN_APP__EGR_PORT__ETHERNET 26
#define CANCUN_APP__EGR_PORT__HG2_PORT 27
#define CANCUN_APP__EGR_PORT__LOOPBACK 28
#define CANCUN_APP__EGR_PORT__QOS_LAYERED_RESOLUTION 29
#define CANCUN_APP__EGR_PORT__QOS_SERIAL_RESOLUTION 30
#define CANCUN_APP__RTAG7_HASH_CONTROL__SPI_EXTRACTION 31
/* CMH Format 4 Application IDs*/
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_EGRESS_MIRROR_LOCAL_MTP 32
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_EGRESS_MIRROR_REMOTE_MTP 33
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_EGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 34
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_EGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 35
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_INGRESS_MIRROR_LOCAL_MTP 36
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_INGRESS_MIRROR_REMOTE_MTP 37
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_INGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 38
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_INGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 39
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_EGRESS_MIRROR_LOCAL_MTP 40
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_EGRESS_MIRROR_REMOTE_MTP 41
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_EGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 42
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_EGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 43
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_INGRESS_MIRROR_LOCAL_MTP 44
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_INGRESS_MIRROR_REMOTE_MTP 45
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_INGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 46
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_UNTAG_INGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 47
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_LOCAL_MTP 48
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_REMOTE_MTP 49
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_TRUNCATE_LOCAL_MTP 50
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_TRUNCATE_REMOTE_MTP 51
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_UNTAG_LOCAL_MTP 52
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_UNTAG_REMOTE_MTP 53
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_EGRESS_MIRROR_LOCAL_MTP 54
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_INGRESS_MIRROR_LOCAL_MTP 55
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_ETAG_LOCAL_MTP 56
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_ETAG_OTAG_LOCAL_MTP 57
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_ETAG_OTAG_REMOTE_MTP 58
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_ETAG_REMOTE_MTP 59
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_INGRESS_MIRROR_LOCAL_MTP 60
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_INGRESS_MIRROR_REMOTE_MTP 61
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_UNTAG_INGRESS_MIRROR_LOCAL_MTP 62
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_UNTAG_INGRESS_MIRROR_REMOTE_MTP 63
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_VNTAG_LOCAL_MTP 64
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_VNTAG_OTAG_LOCAL_MTP 65
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_VNTAG_OTAG_REMOTE_MTP 66
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_VNTAG_REMOTE_MTP 67

/* Newly added */
#define CANCUN_APP__VFI__DEFAULT 68
#define CANCUN_APP__SOURCE_TRUNK_MAP__GPE_NSH_ENCAP 69
#define CANCUN_APP__PORT_TABLE__MIM_MC_TERM_DISABLE 70

/* Newly added in 4.28.1.10 */
/* CMH Format 3 Application IDs*/
#define CANCUN_APP__EGR_MIRROR_TABLE__EGRESS_MIRROR  71
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN3_INGRESS_MIRROR  72
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_GRE_SEQUENCE_EGRESS_MIRROR  73
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_GRE_SEQUENCE_INGRESS_MIRROR  74
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_IPV6  75
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_TRUNCATE  76
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_UNTAG  77
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_VNTAG_OTAG  78
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_EGRESS_MIRROR_WITH_VNTAG  79
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_INGRESS_MIRROR_WITH_VNTAG  80
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW  81
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_ETAG  82
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_ETAG_OTAG  83
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_UNTAG  84
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_VNTAG  85
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_VNTAG_OTAG  86
#define CANCUN_APP__EGR_MIRROR_TABLE__VXLAN_INGRESS_MIRROR  87
#define CANCUN_APP__EGR_MIRROR_TABLE__VXLAN_INGRESS_MIRROR_IPV6  88

/* CMH Format 4 Application IDs*/
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN3_INGRESS_MIRROR_LOCAL_MTP 89
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN3_INGRESS_MIRROR_REMOTE_MTP 90
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_GRE_SEQUENCE_EGRESS_MIRROR_LOCAL_MTP 91
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_GRE_SEQUENCE_EGRESS_MIRROR_REMOTE_MTP 92
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_GRE_SEQUENCE_INGRESS_MIRROR_LOCAL_MTP 93
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN_GRE_SEQUENCE_INGRESS_MIRROR_REMOTE_MTP 94
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_VNTAG_OTAG_LOCAL_MTP 95
#define CANCUN_APP__EGR_MIRROR_TABLE__PSAMP_VNTAG_OTAG_REMOTE_MTP 96
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_EGRESS_MIRROR_WITH_VNTAG_LOCAL_MTP 97
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_EGRESS_MIRROR_WITH_VNTAG_REMOTE_MTP 98
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_INGRESS_MIRROR_WITH_VNTAG_LOCAL_MTP 99
#define CANCUN_APP__EGR_MIRROR_TABLE__RSPAN_INGRESS_MIRROR_WITH_VNTAG_REMOTE_MTP 100
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_LOCAL_MTP 101
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_REMOTE_MTP 102
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_UNTAG_LOCAL_MTP 103
#define CANCUN_APP__EGR_MIRROR_TABLE__SFLOW_UNTAG_REMOTE_MTP 104
#define CANCUN_APP__EGR_MIRROR_TABLE__VXLAN_INGRESS_MIRROR_IPV6_LOCAL_MTP 105
#define CANCUN_APP__EGR_MIRROR_TABLE__VXLAN_INGRESS_MIRROR_IPV6_REMOTE_MTP 106
#define CANCUN_APP__EGR_MIRROR_TABLE__VXLAN_INGRESS_MIRROR_LOCAL_MTP 107
#define CANCUN_APP__EGR_MIRROR_TABLE__VXLAN_INGRESS_MIRROR_REMOTE_MTP 108

/* Newly added in 4.28.1.12*/
/* CCH Format 4 Application IDs*/
#define CANCUN_APP__MIRROR__ERSPAN3_INGRESS_MIRROR_LOCAL_MTP 109
#define CANCUN_APP__MIRROR__ERSPAN3_INGRESS_MIRROR_REMOTE_MTP 110
#define CANCUN_APP__MIRROR__ERSPAN_EGRESS_MIRROR_LOCAL_MTP 111
#define CANCUN_APP__MIRROR__ERSPAN_EGRESS_MIRROR_REMOTE_MTP 112
#define CANCUN_APP__MIRROR__ERSPAN_EGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 113
#define CANCUN_APP__MIRROR__ERSPAN_EGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 114
#define CANCUN_APP__MIRROR__ERSPAN_GRE_SEQUENCE_EGRESS_MIRROR_LOCAL_MTP 115
#define CANCUN_APP__MIRROR__ERSPAN_GRE_SEQUENCE_EGRESS_MIRROR_REMOTE_MTP 116
#define CANCUN_APP__MIRROR__ERSPAN_GRE_SEQUENCE_INGRESS_MIRROR_LOCAL_MTP 117
#define CANCUN_APP__MIRROR__ERSPAN_GRE_SEQUENCE_INGRESS_MIRROR_REMOTE_MTP 118
#define CANCUN_APP__MIRROR__ERSPAN_INGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 119
#define CANCUN_APP__MIRROR__ERSPAN_INGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 120
#define CANCUN_APP__MIRROR__ERSPAN_INGRESS_MIRROR_LOCAL_MTP 121
#define CANCUN_APP__MIRROR__ERSPAN_INGRESS_MIRROR_REMOTE_MTP 122
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_EGRESS_MIRROR_LOCAL_MTP 123
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_EGRESS_MIRROR_REMOTE_MTP 124
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_EGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 125
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_EGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 126
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_INGRESS_MIRROR_LOCAL_MTP 127
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_INGRESS_MIRROR_REMOTE_MTP 128
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_INGRESS_MIRROR_UNTAG_PAYLOAD_LOCAL_MTP 129
#define CANCUN_APP__MIRROR__ERSPAN_UNTAG_INGRESS_MIRROR_UNTAG_PAYLOAD_REMOTE_MTP 130
#define CANCUN_APP__MIRROR__PSAMP_IPV6_LOCAL_MTP 131
#define CANCUN_APP__MIRROR__PSAMP_IPV6_REMOTE_MTP 132
#define CANCUN_APP__MIRROR__PSAMP_LOCAL_MTP 133
#define CANCUN_APP__MIRROR__PSAMP_REMOTE_MTP 134
#define CANCUN_APP__MIRROR__PSAMP_TRUNCATE_LOCAL_MTP 135
#define CANCUN_APP__MIRROR__PSAMP_TRUNCATE_REMOTE_MTP 136
#define CANCUN_APP__MIRROR__PSAMP_VNTAG_OTAG_LOCAL_MTP 137
#define CANCUN_APP__MIRROR__PSAMP_VNTAG_OTAG_REMOTE_MTP 138
#define CANCUN_APP__MIRROR__RSPAN_EGRESS_MIRROR_LOCAL_MTP 139
#define CANCUN_APP__MIRROR__RSPAN_EGRESS_MIRROR_WITH_VNTAG_LOCAL_MTP 140
#define CANCUN_APP__MIRROR__RSPAN_EGRESS_MIRROR_WITH_VNTAG_REMOTE_MTP 141
#define CANCUN_APP__MIRROR__RSPAN_INGRESS_MIRROR_LOCAL_MTP 142
#define CANCUN_APP__MIRROR__RSPAN_INGRESS_MIRROR_WITH_VNTAG_LOCAL_MTP 143
#define CANCUN_APP__MIRROR__RSPAN_INGRESS_MIRROR_WITH_VNTAG_REMOTE_MTP 144
#define CANCUN_APP__MIRROR__SFLOW_ETAG_LOCAL_MTP 145
#define CANCUN_APP__MIRROR__SFLOW_ETAG_OTAG_LOCAL_MTP 146
#define CANCUN_APP__MIRROR__SFLOW_ETAG_OTAG_REMOTE_MTP 147
#define CANCUN_APP__MIRROR__SFLOW_ETAG_REMOTE_MTP 148
#define CANCUN_APP__MIRROR__SFLOW_LOCAL_MTP 149
#define CANCUN_APP__MIRROR__SFLOW_UNTAG_LOCAL_MTP 150
#define CANCUN_APP__MIRROR__SFLOW_REMOTE_MTP 151
#define CANCUN_APP__MIRROR__SFLOW_VNTAG_LOCAL_MTP 152
#define CANCUN_APP__MIRROR__SFLOW_VNTAG_OTAG_LOCAL_MTP 153
#define CANCUN_APP__MIRROR__SFLOW_VNTAG_OTAG_REMOTE_MTP 154
#define CANCUN_APP__MIRROR__SFLOW_UNTAG_REMOTE_MTP 155
#define CANCUN_APP__MIRROR__SFLOW_VNTAG_REMOTE_MTP 156
#define CANCUN_APP__MIRROR__VXLAN_INGRESS_MIRROR_IPV6_LOCAL_MTP 157
#define CANCUN_APP__MIRROR__VXLAN_INGRESS_MIRROR_IPV6_REMOTE_MTP 158
#define CANCUN_APP__MIRROR__VXLAN_INGRESS_MIRROR_LOCAL_MTP 159
#define CANCUN_APP__MIRROR__VXLAN_INGRESS_MIRROR_REMOTE_MTP 160
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN3_INGRESS_MIRROR_IFP_SGT 161
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN3_INGRESS_MIRROR_NO_SUBHDR_IFP_SGT 162
/* CMH Format 3 Application IDs */
#define CANCUN_APP__EGR_LPORT_PROFILE__ERSPAN3_MIRROR 163
#define CANCUN_APP__EGR_MIRROR_TABLE__ERSPAN3_INGRESS_MIRROR_NO_SUBHDR 164

#define CANCUN_APP__MIRROR__ERSPAN3_INGRESS_MIRROR_NO_SUBHDR_REMOTE_MTP 165
#define CANCUN_APP__MIRROR__ERSPAN3_INGRESS_MIRROR_NO_SUBHDR_LOCAL_MTP 166

#define CANCUN_APP__EGR_MIRROR_TABLE__INT_PROBE 167

#define CANCUN_APP__EGR_GPP_ATTRIBUTES__ERSPAN3_VXLAN_MIRROR 168

#define CANCUN_APP__MIRROR__IFA_EGRESS_MIRROR_LOCAL_MTP 169

#define CANCUN_APP__MIRROR__INGRESS_MIRROR_WITH_INT_PROBE 170

#define CANCUN_APP_NUM 171

#define CANCUN_APP_INVALID -1


#endif /* _CANCUN_ENUMS_H_ */
