/*
* $Id: $
* $Copyright: (c) 2018 Broadcom.
* Broadcom Proprietary and Confidential. All rights reserved.$
*
* $File:  maverick2_ep_flexport.h
*/


#ifndef MAVERICK2_EP_FLEXPORT_H
#define MAVERICK2_EP_FLEXPORT_H

/* Transmit Start Count */
typedef struct soc_mv2_edb_xmit_start_count_s {
    /* NOTE: DON'T ALTER FIELD ORDER */
    uint8 oversub_1616;     /* 1.616 Oversub Ratio */
    uint8 oversub_2000;     /* 2.000 Oversub Ratio */
    uint8 oversub_2155;     /* 2.155 Oversub Ratio */
} soc_mv2_edb_xmit_start_count_t;

/* EP2MMU and Prebuffer core config */
typedef struct soc_mv2_ep_cfg_s {
    /* NOTE: DON'T ALTER FIELD ORDER */
    int speed;
    int egr_mmu_credit_1616;                             /* PFC Optimized */
    int egr_mmu_credit_2155;                             /* Higher ovs ratio or less than max freq */
    soc_mv2_edb_xmit_start_count_t xmit_cnt_l2_latency;  /* L2 Latency Mode */
    soc_mv2_edb_xmit_start_count_t xmit_cnt_l3_latency;  /* L3, Full Latency Modes */
    soc_mv2_edb_xmit_start_count_t xmit_cnt_full_latency;/* L3, Full Latency Modes */
} soc_mv2_ep_core_cfg_t;


extern int soc_maverick2_flex_ep_port_down(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int
soc_maverick2_flex_ep_reconfigure_remove(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int
soc_maverick2_flex_ep_reconfigure_add(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int soc_maverick2_flex_ep_port_up(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int
soc_maverick2_ep_display_xmit_cnt(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int
soc_maverick2_ep_flexport_remove_ports_shim(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int
soc_maverick2_ep_flexport_add_ports_shim(
    int unit, soc_port_schedule_state_t *port_schedule_state);


extern int
soc_maverick2_ep_flexport_enable_ports_shim(
    int unit, soc_port_schedule_state_t *port_schedule_state);


#endif
